
const complotDB = require('../database/ComplotDB.js');

class InformeMoi{
    constructor(client){
        this.client = client;
        this.channels = this.client.channels.cache;
        this.actorRE = new RegExp('<actor>', 'gi'); 
        this.wantRE = new RegExp('<want>', 'gi'); 
        this.reasonRE = new RegExp('<reason>', 'gi'); 
        this.sourceRE = new RegExp('<source>', 'gi'); 
        this.actionRE = new RegExp('<action>', 'gi'); 
    }

    fillAllRandomObject(sentence, regularExpr, randomMethode){
        const matches = sentence.matchAll(regularExpr);
        const size = matches.length;
        let objectString = "";
        let newSentence = sentence;
        for(let match of matches){
            objectString = randomMethode();
            newSentence = newSentence.replace(match, objectString);
        }
        if(size === 1 && regularExpr === this.actorRE){
            const want = objectString.startsWith("Les ") ? "veulent" : "veut";
            newSentence = newSentence.remplace(match, want );
        }
        
        return newSentence;
    }

    getRandomComplot(){
        let sentence = complotDB.getRandomSentence();

        sentence = this.fillAllRandomObject(sentence, this.actorRE, complotDB.getRandomActor.bind(complotDB));
        sentence = this.fillAllRandomObject(sentence, this.actionRE, complotDB.getRandomAction.bind(complotDB));
        sentence = this.fillAllRandomObject(sentence, this.reasonRE, complotDB.getRandomReason.bind(complotDB));
        sentence = this.fillAllRandomObject(sentence, this.sourceRE, complotDB.getRandomSource.bind(complotDB));
        
        sentence.replaceAll(this.wantRE, 'veut'); /**Todo, change */
        return sentence;
    }

    parse(message){
        if(this.shouldRespond(message)){
            message.reply(this.getRandomComplot());
        }
    }

    shouldRespond(message){    
        return message.content.toLowerCase().includes("informe moi");
    }
}

module.exports = InformeMoi;